-- ====================================================================
--                  Procedimento para atualizar estoque - Manage
--                  ------------ ---- --------- -------
--
--  Parmetros: P_FILIMOVI   = Cdigo da filial a ser considerada.
--              P_DTINICIAL  = Data inicial para clculo de estoque.
--              P_DTFINAL    = Data final para clculo de estoque.
--              P_FILILANCTO = Cdigo da filial de lanamento.
--              P_NRLANCTO   = Nmero de um lanamento (Opcional).
--              P_CDPRODUTO  = Cdigo do produto a ser evoludo (Opcional).
--
--  @C:\Web_572\Sql\End_Conv\Oracle\4012_ESTSTPO_Atualiza_Estoque_Manage.SQL
--
-- raise_application_error(-20501, '' , True);
-- ====================================================================
CREATE OR REPLACE PROCEDURE ATUALIZA_ESTOQUE_MANAGE(
   P_FILIMOVI    IN ITLANCTOEST.CDFILIMOVI%TYPE,
   P_DTINICIAL   IN ITLANCTOEST.DTLANCMOVI%TYPE,
   P_DTFINAL     IN ITLANCTOEST.DTLANCMOVI%TYPE,
   P_FILILANCTO  IN ITLANCTOEST.CDFILIAL%TYPE,
   P_NRLANCTO    IN ITLANCTOEST.NRLANCESTQ%TYPE DEFAULT NULL,
   P_IDBLOQTRANS IN ITLANCTOEST.IDEVOLESTOQ%TYPE DEFAULT 'N')
AS

BEGIN

   DECLARE

      V_FILIAUX       VARCHAR2(04);

  BEGIN

     ATUALIZA_ESTOQUE (P_FILIMOVI,P_DTINICIAL,P_DTFINAL,P_FILILANCTO,P_NRLANCTO);

     /* Produtos que no tiveram seu estoque atualizado pois no pode ficar negativo tem que ser atualizado abaixo */
     FOR C_PRODIRREG IN ( SELECT NRMOVILOTE, CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ,
                                 CDPRODUTO, NRLOTEESTQ, NRSUBLOTE
                            FROM MOVILOTE
                            WHERE NRMOVILOTE  = P_FILIMOVI||P_NRLANCTO
                              AND CDFILIAL    = P_FILILANCTO ) LOOP

        UPDATE ITLANCTOEST
           SET IDEVOLESTOQ = 'N'
        WHERE CDFILIAL     = C_PRODIRREG.CDFILIAL
          AND NRLANCESTQ   = P_NRLANCTO
          AND CDALMOXARIFE = C_PRODIRREG.CDALMOXARIFE
          AND CDLOCALESTOQ = C_PRODIRREG.CDLOCALESTOQ
          AND CDPRODUTO    = C_PRODIRREG.CDPRODUTO
          AND NRLOTEESTQ   = C_PRODIRREG.NRLOTEESTQ
          AND NRSUBLOTE    = C_PRODIRREG.NRSUBLOTE;
     END LOOP;

     DELETE MOVILOTE
     WHERE NRMOVILOTE = P_FILIMOVI||P_NRLANCTO;
     
  END;
  
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZA_ESTOQUE_MANAGE','5.72.XXX'); END;
/

